# Wanted release 2 by Steven Hartin
# ./addons/eventscripts/wanted/wanted.py

# >>> To configure this addon please see wanted_config.cfg <<<

import es, langlib, playerlib, os.path, services

info = es.AddonInfo()
info.name = 'Wanted'
info.version = '1.1'
info.url = 'http://addons.eventscripts.com/addons/view/wanted'
info.basename = 'wanted'
info.author = 'Freddukes AKA Pro Noob'

text = None
wanted = {}
tokens = {}
dict_options = {'wanted_tk':[1,'1 = on: 0 = off: Enable TK punishment with a bounty'],'wanted_value':[1000,'The value of the bounty when a user TKs'],'wanted_multiplier':[0.05,'Amount to multiply everyones bounty by if they survive the round']}

def load():
    global text
    
    es.load('examples/auth/basic_auth')
    setup_auth()
    
    for a in dict_options:
        es.ServerVar(a,dict_options[a][0],dict_options[a][1])
    
    if not es.exists('saycommand','wanted'):
        es.regsaycmd('wanted','wanted/addToList','Usage: wanted <userid> <value> [reason]')
    if not es.exists('command','wanted'):
        es.regcmd('wanted','wanted/addToList','Usage: wanted <userid> <value> [reason]')
    if not es.exists('clientcommand','wanted'):
        es.regclientcmd('wanted','wanted/addToList','Usage: wanted <userid> <value> [reason]')
    
    langpath = es.getAddonPath('wanted') + '/languages.ini'
    if os.path.isfile(langpath):
        text = langlib.Strings(langpath)
    else:
        es.dbgmsg(0, 'Wanted: Unable to load languages.ini! Please ensure it is in the ./wanted/ directory.')
    if not text:
        text = missing_lang
    
    if os.path.isfile(es.getAddonPath('wanted') + '/wanted_config.cfg'):
        es.server.cmd('es_xmexec ../addons/eventscripts/wanted/wanted_config.cfg')
    else:
        es.dbgmsg(0, 'Wanted: Unable to load wanted_config.cfg! Please ensure it is in the ./wanted/ directory.')
        
def setup_auth():
   global isAuthed
   if services.isRegistered('auth'):
      auth_service = services.use('auth')
      auth_service.registerCapability('test_auth', auth_service.ADMIN)
      isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'test_auth')
   else:
      isAuthed = lambda x: False

def player_spawn(ev):
    if wanted.has_key(ev['userid']):
        global tokens
        tokens.clear()
        tokens = {'bounty':wanted[ev['userid']],'dollar':'$'}
        es.tell(ev['userid'],'#multi',text('spawn message', tokens, playerlib.getPlayer(ev['userid']).get('lang')))

def addToList():
    if isAuthed(es.getcmduserid()): 
        tempid = str(es.getargv(1))
        if tempid[0] in ['1','2','3','4','5','6','7','8','9']:
            uid = str(es.getargv(1))
        else:
            uid = str(es.getuserid(es.getargv(1)))      
        value = str(es.getargv(2))
        length = es.getargc()
        if length > 3:
            index = 3
            reason = ''
            while index <= es.getargc():
                 reason = reason + ' ' + str(es.getargv(index))
                 index += 1
        if uid != None and value[0] in ['1','2','3','4','5','6','7','8','9']:
            if not wanted.has_key(uid):
                if length > 3:
                    if reason:
                        setBounty(uid,value,reason)
                else:
                    setBounty(uid,value,0)
            else:
                global tokens
                tokens.clear()
                tokens = {'bounty':wanted[uid],'dollar':'$'}
                es.tell(es.getcmduserid(),'#multi',text('has bounty already',tokens,playerlib.getPlayer(es.getcmduserid()).get('lang')))
        else:
            es.tell(es.getcmduserid(),'#multi', text('incorect syntax',playerlib.getPlayer(es.getcmduserid()).get('lang')))
    else:
        es.tell(es.getcmduserid(),'#green', text('unauthorized',playerlib.getPlayer(es.getcmduserid()).get('lang')))

def player_death(ev):
    if ev['userid'] in wanted and ev['es_userteam'] != ev['es_attackerteam'] and int(ev['attacker']):
        global tokens
        money = int(es.getplayerprop(ev['attacker'],'CCSPlayer.m_iAccount'))
        money += int(wanted[ev['userid']])
        es.setplayerprop(ev['attacker'],'CCSPlayer.m_iAccount',money)
        tokens.clear()
        tokens = {'attacker':ev['es_attackername'],'victim':ev['es_username'],'bounty':wanted[ev['userid']],'dollar':'$'}
        for a in es.getUseridList():
            es.tell(a,'#multi',text('bounty stole',tokens,playerlib.getPlayer(a).get('lang')))
        del wanted[ev['userid']]
    elif ev['es_userteam'] == ev['es_attackerteam'] and ev['attacker'] != ev['userid'] and es.ServerVar('wanted_tk'):
        if not wanted.has_key(ev['attacker']):
            setBounty(str(ev['attacker']),es.ServerVar('wanted_value'),' ' + text('tking'))
        else:
            setBounty(str(ev['attacker']),int(wanted[ev['attacker']]) + es.ServerVar('wanted_value'),' ' + text('another tk') )

def setBounty(uid,value,reason):
    global wanted
    wanted[uid] = str(value)
    if reason:
        global tokens
        tokens.clear()
        tokens = {'user':es.getplayername(uid),'reason':reason,'bounty':value,'dollar':'$'}
        for a in es.getUseridList():
            es.tell(a,'#multi',text('started a bounty with reason',tokens,playerlib.getPlayer(a).get('lang')))
    else:
        global tokens
        tokens.clear()
        tokens = {'user':es.getplayername(uid),'bounty':value,'dollar':'$'}
        for a in es.getUseridList():
            es.tell(a,'#multi',text('started a bounty without reason',tokens,playerlib.getPlayer(a).get('lang')))

def player_disconnect(ev):
    if wanted.has_key(ev['userid']):
        global wanted
        del wanted[ev['userid']] 

def round_end(ev):
    wm = float(es.ServerVar('wanted_multiplier'))
    if wm:
        for a in wanted:
            value = int(wanted[a])
            value = int('%i'%round(value + value * wm))
            if value > 16000:
                value = 16000
            wanted[a] = str(value)
            
